import { createEvent, h, proxyCustomElement } from '@stencil/core/internal/client';
export { setAssetPath } from '@stencil/core/internal/client';

class ControlInfoValue {
    static getAtomicValues_impl(values) {
        var _a;
        return (_a = values === null || values === void 0 ? void 0 : values.map(value => { var _a; return (((_a = value.items) === null || _a === void 0 ? void 0 : _a.length) > 0 ? ControlInfoValue.getAtomicValues_impl(value.items) : [value]); }).reduce((a, b) => a.concat(b), [])) !== null && _a !== void 0 ? _a : [];
    }
    static containsDetails(values) {
        var _a;
        return (_a = (values === null || values === void 0 ? void 0 : values.filter(value => value.detail != '' && value.detail != undefined).length) != 0) !== null && _a !== void 0 ? _a : false;
    }
    static containsIcons(values) {
        var _a;
        return (_a = (values === null || values === void 0 ? void 0 : values.filter(value => value.imageUrl != '' && value.imageUrl != undefined).length) != 0) !== null && _a !== void 0 ? _a : false;
    }
    static containsTrailingText(values) {
        var _a;
        return (_a = (values === null || values === void 0 ? void 0 : values.filter(value => value.trailingText != '' && value.trailingText != undefined).length) != 0) !== null && _a !== void 0 ? _a : false;
    }
}

const k2btEnhancedcomboCss = ":host{display:block}.K2BTEnhancedComboHeader{border-bottom:1px solid #ccc}.K2BTEnhancedComboHeader:after{content:'▼';width:0px}.K2BTEnhancedComboContentsOpen{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:absolute;border:1px solid #ccc;background-color:#fff;z-index:1}.K2BTEnhancedComboSearchInput{width:100%}.K2BTEnhancedComboItems{max-height:300px;overflow:auto;scrollbar-width:thin;scrollbar-color:#d7d7d7 transparent}.K2BTEnhancedComboItems::-webkit-scrollbar{width:6px}.K2BTEnhancedComboItems::-webkit-scrollbar-thumb{background-color:#d7d7d7;border:1px solid transparent;cursor:pointer}.K2BTEnhancedComboContentsClosed{display:none}.K2BTEnhancedComboItem{display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;padding:8px}.K2BTEnhancedComboItem:hover{background-color:#ddd;cursor:pointer}.K2BTEnhancedComboItem_TextContainer{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-positive:1;flex-grow:1}.K2BTEnhancedComboSubtitle{font-size:12px}.K2BTEnhancedComboCategoryName{padding-left:5px}.K2BTEnchancedComboCategoryContents .K2BTEnhancedComboItem{padding-left:10px}.K2BTEnhancedComboIcon{width:30px;height:30px;-o-object-fit:cover;object-fit:cover;margin-right:4px}.K2BTEnhancedComboIconInvisible{visibility:hidden}.K2BTEnhancedComboNoItemsFound{width:100%;text-align:center;margin-top:40px;margin-bottom:40px}.K2BTEnhancedComboTrailingText{-ms-flex-positive:0;flex-grow:0}";

const K2btEnhancedcombo = class extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.changeEvent = createEvent(this, "change", 7);
        this.searchChangedEvent = createEvent(this, "searchChanged", 7);
        this.newRecordClickedEvent = createEvent(this, "newRecordClicked", 7);
        this.value = null;
        this.includesearch = true;
        this.includeemptyitem = true;
        this.emptyitemtext = '(none)';
        this.noresultsfoundtext = 'No results found';
        this.enableadditem = true;
        this.additemcaption = 'New record';
        this.searchfieldplaceholder = 'Search';
        this.searchvalue = '';
        this.enabled = true;
        this.readonlyclass = '';
        this.container = null;
        this.selectedElement = null;
        this.searchfield = null;
        this._keyboardSearchPrefix = '';
        this._keyboardSearchLastKeystroke = null;
    }
    processKeydown(event) {
        if (event.key == 'Escape') {
            this.resetPrefixSearch();
            // escape key
            this.open = false;
            event.stopPropagation();
        }
        else if (event.key == 'Enter') {
            this.resetPrefixSearch();
            // enter key
            this.open = !this.open;
            event.stopPropagation();
            return false;
        }
        else if (event.key == 'ArrowDown') {
            this.resetPrefixSearch();
            event.stopPropagation();
            event.preventDefault();
            //down key
            var currentValues = ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
            if (currentValues.length > 0) {
                var pos = currentValues.findIndex(v => v.value.trim() == this.value.trim());
                if (pos == -1) {
                    this.setValueWithoutClosing(currentValues[0].value.trim());
                }
                else {
                    pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
                    this.setValueWithoutClosing(currentValues[pos].value.trim());
                }
            }
        }
        else if (event.key == 'ArrowUp') {
            this.resetPrefixSearch();
            event.stopPropagation();
            event.preventDefault();
            //up key
            var currentValues = ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
            if (currentValues.length > 0) {
                var pos = currentValues.findIndex(v => v.value.trim() == this.value.trim());
                if (pos == -1) {
                    this.setValueWithoutClosing(currentValues[currentValues.length - 1].value.trim());
                }
                else {
                    pos = (((pos - 1) % currentValues.length) + currentValues.length) % currentValues.length;
                    this.setValueWithoutClosing(currentValues[pos].value.trim());
                }
            }
        }
        else {
            var key = event.key;
            // Check if the key pressed maps to a single character
            if (key.length == 1) {
                if (document.activeElement != this.searchfield) {
                    var currentDate = Date.now();
                    if (this._keyboardSearchLastKeystroke == null || currentDate - this._keyboardSearchLastKeystroke > 3000) {
                        this._keyboardSearchPrefix = '';
                    }
                    this._keyboardSearchPrefix = this._keyboardSearchPrefix + key;
                    var currentValues = ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
                    var selectedValue = currentValues.find(v => v.description.toLowerCase().indexOf(this._keyboardSearchPrefix.toLowerCase()) == 0);
                    if (selectedValue != null) {
                        this.setValueWithoutClosing(selectedValue.value.trim());
                    }
                    this._keyboardSearchLastKeystroke = currentDate;
                }
            }
        }
    }
    onFocusIn() {
        this.resetPrefixSearch();
    }
    resetPrefixSearch() {
        this._keyboardSearchLastKeystroke = null;
    }
    closeMenu(ev) {
        this.resetPrefixSearch();
        if (!this.container.contains(ev.target))
            this.open = false;
    }
    getHeaderContent() {
        if (this.value == null)
            return this.emptyitemtext;
        else
            var vals = this.getAtomicValues().filter(value => value.value.trim() == this.value.trim());
        if (vals.length > 0)
            return vals[0].description;
        else
            return this.emptyitemtext;
    }
    toggleContentVisibilty() {
        this.resetPrefixSearch();
        this.open = !this.open;
    }
    getRawValues() {
        var result;
        if (this.values == null) {
            result = [];
        }
        else if (typeof this.values === 'string') {
            if (this.values == '')
                result = [];
            else
                result = JSON.parse(this.values);
        }
        else {
            result = [...this.values];
        }
        if (this.includeemptyitem) {
            result.unshift({
                value: '',
                description: this.emptyitemtext,
                imageUrl: '',
                detail: '',
                trailingText: '',
                items: [],
            });
        }
        return result;
    }
    getFilteredValues() {
        var result = this.getRawValues();
        if (this.includesearch && this.searchvalue != '')
            result = this.getFilteredValues_impl(result);
        return result;
    }
    getFilteredValues_impl(origin) {
        var result = [];
        if (origin != undefined) {
            for (let cv of origin) {
                if (cv.description.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1 ||
                    cv.detail.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1 ||
                    cv.trailingText.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1) {
                    result = result.concat(cv);
                }
                else {
                    // Check if child items must be added
                    var filteredChildren = this.getFilteredValues_impl(cv.items);
                    if (filteredChildren.length > 0) {
                        var cv2 = Object.assign({}, cv);
                        cv2.items = filteredChildren;
                        result = result.concat(cv2);
                    }
                }
            }
        }
        return result;
    }
    setValue(value) {
        this.setValueWithoutClosing(value);
        this.open = false;
    }
    setValueWithoutClosing(value) {
        this.value = value;
        this.changeEvent.emit(value);
    }
    changeSearchValue(value) {
        this.searchvalue = value;
        this.searchChangedEvent.emit({ value });
    }
    onIncludeNewRecordClick() {
        this.open = false;
        this.newRecordClickedEvent.emit(null);
    }
    render() {
        this.selectedElement = null;
        return (h("div", null, h("p", { class: "form-control-static", style: this.enabled ? { display: 'none' } : {} }, h("span", { class: this.readonlyclass }, this.getHeaderContent())), h("div", { tabindex: "0", class: "K2BTEnhancedCombo", ref: node => (this.container = node), style: !this.enabled ? { display: 'none' } : {} }, h("div", { class: "K2BTEnhancedComboHeader", onClick: () => this.toggleContentVisibilty() }, this.getHeaderContent()), h("div", { class: this.open ? 'K2BTEnhancedComboContentsOpen' : 'K2BTEnhancedComboContentsClosed' }, this.includesearch ? (h("input", { type: "text", class: "K2BTEnhancedComboSearchInput", ref: c => (this.searchfield = c), onInput: event => this.changeSearchValue(event.target.value), placeholder: this.searchfieldplaceholder })) : (''), h("div", { class: "K2BTEnhancedComboItems" }, this.getComboContent()), this.enableadditem ? (h("span", { class: "K2BTEnhancedComboNewAction", onClick: () => this.onIncludeNewRecordClick() }, this.additemcaption)) : ('')))));
    }
    getAtomicValues() {
        return ControlInfoValue.getAtomicValues_impl(this.getRawValues());
    }
    getComboContent() {
        const rawValues = ControlInfoValue.getAtomicValues_impl(this.getRawValues());
        var containsDetails = ControlInfoValue.containsDetails(rawValues);
        var containsIcons = ControlInfoValue.containsIcons(rawValues);
        var containsTrailingText = ControlInfoValue.containsTrailingText(rawValues);
        const filteredValues = !this.open ? [] : this.getFilteredValues();
        if (filteredValues.length > 0)
            return filteredValues.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText));
        else
            return h("div", { class: "K2BTEnhancedComboNoItemsFound" }, this.noresultsfoundtext);
    }
    onImageError(e) {
        e.target.classList.add('K2BTEnhancedComboIconInvisible');
    }
    getItemContent(item, containsDetails, containsIcons, containsTrailingText) {
        var _a;
        if (((_a = item.items) === null || _a === void 0 ? void 0 : _a.length) > 0) {
            // Item is a category
            return (h("div", { class: "K2BTEnhancedComboCategory" }, h("span", { class: "K2BTEnhancedComboCategoryName" }, item.description), h("div", { class: "K2BTEnchancedComboCategoryContents" }, item.items.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText)))));
        }
        else {
            return (h("div", { class: this.value.trim() == item.value.trim() ? 'K2BTEnhancedComboItem K2BTEnhancedComboSelected' : 'K2BTEnhancedComboItem', ref: c => {
                    if (this.value.trim() == item.value.trim())
                        this.selectedElement = c;
                }, onClick: () => this.setValue(item.value.trim()) }, containsIcons ? (h("div", { class: "K2BTEnhancedComboIconContainer" }, h("img", { class: "K2BTEnhancedComboIcon", src: item.imageUrl, onError: e => this.onImageError(e) }))) : (''), h("div", { class: "K2BTEnhancedComboItem_TextColumn" }, h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, h("span", { class: "K2BTEnhancedComboDescription" }, this.getHighlightedText(item.description)), containsTrailingText ? h("span", { class: "K2BTEnhancedComboTrailingText" }, this.getHighlightedText(item.trailingText)) : ''), h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, containsDetails ? h("span", { class: "K2BTEnhancedComboSubtitle" }, this.getHighlightedText(item.detail)) : ''))));
        }
    }
    getHighlightedText(originalText) {
        var position = originalText.toLowerCase().indexOf(this.searchvalue.toLowerCase());
        if (this.searchvalue == undefined || this.searchvalue == '' || position == -1) {
            return h("span", null, originalText);
        }
        else {
            return (h("span", null, originalText.substring(0, position), h("span", { class: "K2BTEnhancedComboSearchHighlight" }, originalText.substring(position, position + this.searchvalue.length)), this.getHighlightedText(originalText.substring(position + this.searchvalue.length))));
        }
    }
    componentDidRender() {
        if (this.selectedElement != null) {
            this.selectedElement.scrollIntoView({ block: 'nearest' });
        }
    }
    componentDidLoad() {
        var currentValues = this.getAtomicValues();
        if (!this.includeemptyitem && currentValues.filter(v => v.value.trim() == this.value.trim()).length == 0) {
            if (currentValues.length > 0) {
                this.setValueWithoutClosing(currentValues[0].value.trim());
            }
        }
    }
    static get style() { return k2btEnhancedcomboCss; }
};

const k2btEnhancedsuggestCss = ":host{display:block}.K2BTEnhancedCombo{float:left}.K2BTEnhancedComboHeader{border-bottom:1px solid #ccc}.K2BTEnhancedComboHeader:after{content:'▼';width:0px}.K2BTEnhancedComboContentsOpen{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:absolute;border:1px solid #ccc;background-color:#fff;z-index:1}.K2BTEnhancedComboSearchInput{width:100%}.K2BTEnhancedComboItems{max-height:300px;overflow:auto;scrollbar-width:thin;scrollbar-color:#d7d7d7 transparent}.K2BTEnhancedComboItems::-webkit-scrollbar{width:6px}.K2BTEnhancedComboItems::-webkit-scrollbar-thumb{background-color:#d7d7d7;border:1px solid transparent;cursor:pointer}.K2BTEnhancedComboContentsClosed{display:none}.K2BTEnhancedComboItem{display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;padding:8px}.K2BTEnhancedComboItem:hover{background-color:#ddd;cursor:pointer}.K2BTEnhancedComboItem_TextContainer{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-positive:1;flex-grow:1}.K2BTEnhancedComboSubtitle{font-size:12px}.K2BTEnhancedComboCategoryName{padding-left:5px}.K2BTEnchancedComboCategoryContents .K2BTEnhancedComboItem{padding-left:10px}.K2BTEnhancedComboIcon{width:30px;height:30px;-o-object-fit:cover;object-fit:cover;margin-right:4px}.K2BTEnhancedComboIconInvisible{visibility:hidden}.K2BTEnhancedComboNoItemsFound{width:100%;text-align:center;margin-top:40px;margin-bottom:40px}.K2BTEnhancedComboTrailingText{-ms-flex-positive:0;flex-grow:0}";

const K2btEnhancedsuggest = class extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.changeEvent = createEvent(this, "change", 7);
        this.newRecordClickedEvent = createEvent(this, "newRecordClicked", 7);
        this.inputValueChangedEvent = createEvent(this, "inputValueChanged", 7);
        this.value = null;
        this.noresultsfoundtext = 'No results found';
        this.enableadditem = true;
        this.additemcaption = 'New record';
        this.enabled = true;
        this.readonlyclass = '';
        this.searchvalue = '';
        this.placeholder = '';
        this.container = null;
        this.selectedElement = null;
    }
    processKeydown(event) {
        if (event.which == 27) {
            // escape key
            this.open = false;
            event.stopPropagation();
        }
        if (event.which == 13) {
            // enter key
            this.open = !this.open;
            this.searchvalue = this.getValueDescription();
            event.stopPropagation();
            return false;
        }
        if (this.open) {
            if (event.which == 40) {
                event.stopPropagation();
                event.preventDefault();
                //down key
                var currentValues = ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
                if (currentValues.length > 0) {
                    var pos = currentValues.findIndex(v => v.value == this.value);
                    if (pos == -1) {
                        this.setValueWithoutClosing(currentValues[0].value);
                    }
                    else {
                        pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
                        this.setValueWithoutClosing(currentValues[pos].value);
                    }
                }
            }
            else if (event.which == 38) {
                event.stopPropagation();
                event.preventDefault();
                //up key
                var currentValues = ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
                if (currentValues.length > 0) {
                    var pos = currentValues.findIndex(v => v.value == this.value);
                    if (pos == -1) {
                        this.setValueWithoutClosing(currentValues[currentValues.length - 1].value);
                    }
                    else {
                        pos = (((pos - 1) % currentValues.length) + currentValues.length) % currentValues.length;
                        this.setValueWithoutClosing(currentValues[pos].value);
                    }
                }
            }
        }
    }
    closeMenu(ev) {
        if (!this.container.contains(ev.target))
            this.open = false;
    }
    setValue(value) {
        this.setValueWithoutClosing(value);
        this.searchvalue = this.getValueDescription();
        this.open = false;
    }
    setValueWithoutClosing(value) {
        this.value = value;
        this.changeEvent.emit(value);
    }
    getRawValues() {
        var result;
        if (this.values == null) {
            result = [];
        }
        else if (typeof this.values === 'string') {
            if (this.values == '')
                result = [];
            else
                result = JSON.parse(this.values);
        }
        else {
            result = [...this.values];
        }
        return result;
    }
    getFilteredValues() {
        if (!this.open)
            return [];
        var result = this.getRawValues();
        if (this.searchvalue != '')
            result = this.getFilteredValues_impl(result);
        return result;
    }
    getFilteredValues_impl(origin) {
        var result = [];
        if (origin != undefined) {
            for (let cv of origin) {
                if (cv.description.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1) {
                    result = result.concat(cv);
                }
                else {
                    // Check if child items must be added
                    var filteredChildren = this.getFilteredValues_impl(cv.items);
                    if (filteredChildren.length > 0) {
                        var cv2 = Object.assign({}, cv);
                        cv2.items = filteredChildren;
                        result = result.concat(cv2);
                    }
                }
            }
        }
        return result;
    }
    onIncludeNewRecordClick() {
        this.open = false;
        this.newRecordClickedEvent.emit(null);
    }
    getAtomicValues() {
        return ControlInfoValue.getAtomicValues_impl(this.getRawValues());
    }
    getSuggestPopoverContent() {
        const rawValues = this.getRawValues();
        var containsDetails = ControlInfoValue.containsDetails(rawValues);
        var containsIcons = ControlInfoValue.containsIcons(rawValues);
        var containsTrailingText = ControlInfoValue.containsTrailingText(rawValues);
        const filteredValues = this.getFilteredValues();
        if (filteredValues.length > 0)
            return filteredValues.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText));
        else
            return h("div", { class: "K2BTEnhancedComboNoItemsFound" }, this.noresultsfoundtext);
    }
    onImageError(e) {
        // TODO: Think how to handle this case
        e.target.classList.add('K2BTEnhancedComboIconInvisible');
    }
    getItemContent(item, containsDetails, containsIcons, containsTrailingText) {
        var _a;
        if (((_a = item.items) === null || _a === void 0 ? void 0 : _a.length) > 0) {
            // Item is a category
            return (h("div", { class: "K2BTEnhancedComboCategory" }, h("span", { class: "K2BTEnhancedComboCategoryName" }, item.description), h("div", { class: "K2BTEnchancedComboCategoryContents" }, item.items.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText)))));
        }
        else {
            return (h("div", { class: this.value == item.value ? 'K2BTEnhancedComboItem K2BTEnhancedComboSelected' : 'K2BTEnhancedComboItem', ref: c => {
                    if (this.value == item.value)
                        this.selectedElement = c;
                }, onClick: () => this.setValue(item.value) }, containsIcons ? (h("div", { class: "K2BTEnhancedComboIconContainer" }, h("img", { class: "K2BTEnhancedComboIcon", src: item.imageUrl, onError: e => this.onImageError(e) }))) : (''), h("div", { class: "K2BTEnhancedComboItem_TextColumn" }, h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, h("span", { class: "K2BTEnhancedComboDescription" }, this.getHighlightedText(item.description)), containsTrailingText ? h("span", { class: "K2BTEnhancedComboTrailingText" }, this.getHighlightedText(item.trailingText)) : ''), h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, containsDetails ? h("span", { class: "K2BTEnhancedComboSubtitle" }, this.getHighlightedText(item.detail)) : ''))));
        }
    }
    getHighlightedText(originalText) {
        var position = originalText.toLowerCase().indexOf(this.searchvalue.toLowerCase());
        if (this.searchvalue == undefined || this.searchvalue == '' || position == -1) {
            return h("span", null, originalText);
        }
        else {
            return (h("span", null, originalText.substring(0, position), h("span", { class: "K2BTEnhancedComboSearchHighlight" }, originalText.substring(position, position + this.searchvalue.length)), this.getHighlightedText(originalText.substring(position + this.searchvalue.length))));
        }
    }
    changeSearchValue(value) {
        this.searchvalue = value;
        this.inputValueChangedEvent.emit(null);
    }
    getValueDescription() {
        var values = this.getAtomicValues();
        var v = values.find(val => val.value == this.value);
        if (v != undefined) {
            return v.description;
        }
        return this.value;
    }
    render() {
        this.selectedElement = null;
        return (h("div", null, h("span", { class: this.readonlyclass, style: this.enabled ? { display: 'none' } : {} }, this.getValueDescription()), h("div", { tabindex: "0", class: "K2BTEnhancedCombo", ref: node => (this.container = node), style: !this.enabled ? { display: 'none' } : {} }, h("input", { type: "text", class: "form-control Attribute_Trn K2BTEnhancedSuggestInput", value: this.searchvalue, onInput: event => this.changeSearchValue(event.target.value), placeholder: this.placeholder, onClick: () => (this.open = true) }), h("div", { class: this.open ? 'K2BTEnhancedComboContentsOpen' : 'K2BTEnhancedComboContentsClosed' }, h("div", { class: "K2BTEnhancedComboItems" }, this.getSuggestPopoverContent()), this.enableadditem ? (h("span", { class: "K2BTEnhancedComboNewAction", onClick: () => this.onIncludeNewRecordClick() }, this.additemcaption)) : ('')))));
    }
    static get style() { return k2btEnhancedsuggestCss; }
};

const k2btToggleBarCss = ":host{display:block}";

const K2btToggleBar = class extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.changeEvent = createEvent(this, "change", 7);
        this.newRecordClickedEvent = createEvent(this, "newRecordClicked", 7);
        this.SmallChip = 'SmallChip';
        this.MediumChip = 'MediumChip';
        this.Rectangle = 'Rectangle';
        this.value = null;
        this.values = [];
        this.includeemptyitem = true;
        this.emptyitemtext = '(none)';
        this.noresultsfoundtext = 'No results found';
        this.enableadditem = true;
        this.additemcaption = 'New record';
        this.enabled = true;
        this.readonlyclass = '';
        this.togglestyle = this.MediumChip;
        this.selectedElement = null;
    }
    onImageError(e) {
        e.target.classList.add('K2BT_ToggleBarIconInvisible');
    }
    setValue(value) {
        this.value = value;
        this.changeEvent.emit(value);
    }
    getToggleContent(values, containsDetails, containsIcons, containsTrailingText) {
        if (values.length == 0) {
            return h("div", { class: "K2BT_ToggleBar_NoItems" }, this.noresultsfoundtext);
        }
        else {
            const atomic = values.filter(v => { var _a, _b; return ((_b = (_a = v.items) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) == 0; });
            const currentLevelCategories = values.filter(v => { var _a; return ((_a = v.items) === null || _a === void 0 ? void 0 : _a.length) > 0; });
            var containerClasses = 'K2BT_ToggleBar_Container';
            if (this.togglestyle == this.SmallChip) {
                containerClasses += ' K2BT_ToggleBarSmallChip';
            }
            else if (this.togglestyle == this.Rectangle) {
                containerClasses += ' K2BT_ToggleBarRectangle';
            }
            return (h("div", { class: containerClasses }, atomic.length > 0 ? (h("div", { class: "K2BT_ToggleBarItemContainer" }, atomic.map(item => (h("div", { class: this.value.trim() == item.value.trim() ? 'K2BT_ToggleBarItem K2BT_ToggleBarItemSelected' : 'K2BT_ToggleBarItem', ref: c => {
                    if (this.value.trim() == item.value.trim())
                        this.selectedElement = c;
                }, onClick: () => this.setValue(item.value.trim()) }, containsIcons ? (h("div", { class: "K2BT_ToggleBarIconContainer" }, h("img", { class: "K2BT_ToggleBarIcon", src: item.imageUrl, onError: e => this.onImageError(e) }))) : (''), h("div", { class: "K2BT_ToggleBarItem_TextSection" }, h("div", { class: "K2BT_ToggleBarItem_TextContainer" }, h("span", { class: "K2BT_ToggleBarDescription" }, item.description), containsTrailingText ? h("span", { class: "K2BT_ToggleBarTrailingText" }, item.trailingText) : ''), h("div", { class: "K2BT_ToggleBarItem_TextContainer" }, containsDetails ? h("span", { class: "K2BT_ToggleBarSubtitle" }, item.detail) : ''))))))) : (''), currentLevelCategories.map(c => {
                return (h("div", { class: "K2BT_ToggleBar_CategoryContainer" }, h("div", { class: "K2BT_ToggleBarCategoryName" }, c.description), this.getToggleContent(c.items, containsDetails, containsIcons, containsTrailingText)));
            })));
        }
    }
    getHeaderContent() {
        if (this.value == null)
            return this.emptyitemtext;
        else
            var vals = ControlInfoValue.getAtomicValues_impl(this.getValues()).filter(value => value.value.trim() == this.value.trim());
        if (vals.length > 0)
            return vals[0].description;
        else
            return this.emptyitemtext;
    }
    render() {
        var containsDetails = ControlInfoValue.containsDetails(ControlInfoValue.getAtomicValues_impl(this.values));
        var containsIcons = ControlInfoValue.containsIcons(ControlInfoValue.getAtomicValues_impl(this.values));
        var containsTrailingText = ControlInfoValue.containsTrailingText(ControlInfoValue.getAtomicValues_impl(this.values));
        var valueList = this.getValues();
        if (this.enabled) {
            return this.getToggleContent(valueList, containsDetails, containsIcons, containsTrailingText);
        }
        else {
            return (h("p", { class: "form-control-static" }, h("span", { class: this.readonlyclass }, this.getHeaderContent())));
        }
    }
    getValues() {
        var valueList = [...this.values];
        if (this.includeemptyitem) {
            valueList.unshift({
                value: '',
                description: this.emptyitemtext,
                imageUrl: '',
                detail: '',
                trailingText: '',
                items: [],
            });
        }
        return valueList;
    }
    componentDidLoad() {
        var currentValues = ControlInfoValue.getAtomicValues_impl(this.values);
        if (!this.includeemptyitem && currentValues.filter(v => v.value.trim() == this.value.trim()).length == 0) {
            if (currentValues.length > 0) {
                this.setValue(currentValues[0].value.trim());
            }
        }
    }
    static get style() { return k2btToggleBarCss; }
};

const K2btEnhancedcombo$1 = /*@__PURE__*/proxyCustomElement(K2btEnhancedcombo, [0,"k2bt-enhancedcombo",{"value":[1],"values":[1],"includesearch":[4],"includeemptyitem":[4],"emptyitemtext":[1],"noresultsfoundtext":[1],"open":[4],"enableadditem":[4],"additemcaption":[1],"searchfieldplaceholder":[1],"searchvalue":[1],"enabled":[4],"readonlyclass":[1]},[[0,"keydown","processKeydown"],[0,"focusin","onFocusIn"],[8,"click","closeMenu"]]]);
const K2btEnhancedsuggest$1 = /*@__PURE__*/proxyCustomElement(K2btEnhancedsuggest, [0,"k2bt-enhancedsuggest",{"value":[1],"values":[1],"noresultsfoundtext":[1],"open":[4],"enableadditem":[4],"additemcaption":[1],"enabled":[4],"readonlyclass":[1],"searchvalue":[1],"placeholder":[1]},[[0,"keydown","processKeydown"],[8,"click","closeMenu"]]]);
const K2btToggleBar$1 = /*@__PURE__*/proxyCustomElement(K2btToggleBar, [0,"k2bt-toggle-bar",{"value":[1],"values":[16],"includeemptyitem":[4],"emptyitemtext":[1],"noresultsfoundtext":[1],"enableadditem":[4],"additemcaption":[1],"enabled":[4],"readonlyclass":[1],"togglestyle":[1]}]);
const defineCustomElements = (opts) => {
  if (typeof customElements !== 'undefined') {
    [
      K2btEnhancedcombo$1,
  K2btEnhancedsuggest$1,
  K2btToggleBar$1
    ].forEach(cmp => {
      if (!customElements.get(cmp.is)) {
        customElements.define(cmp.is, cmp, opts);
      }
    });
  }
};

export { K2btEnhancedcombo$1 as K2btEnhancedcombo, K2btEnhancedsuggest$1 as K2btEnhancedsuggest, K2btToggleBar$1 as K2btToggleBar, defineCustomElements };
